package mackthehobbit.ld26;

import java.util.ArrayList;

import mackthehobbit.ld26.item.Item;
import mackthehobbit.ld26.item.ItemStore;

public class CraftMenu {
	private static ArrayList<CraftRecipe> recipes = new ArrayList<CraftRecipe>();
	
	private static CraftRecipe shovel = new CraftRecipe(Item.shovel, 25, 0, 0);
	private static CraftRecipe wall = new CraftRecipe(Item.wall, 1, 1, 0);
	private static CraftRecipe hatchet = new CraftRecipe(Item.hatchet, 25, 5, 0);
	private static CraftRecipe max = new CraftRecipe(Item.max, 50, 30, 20);
	
	private static int selected;
	private static int length;
	
	public static boolean isOpen = false;
	
	public static void prepare() {
		selected = 0;
		length = recipes.size();
		isOpen = true;
	}
	
	public static void tick() {
		if(Game.input.down.isPressed()) {
			selected++;
		}
		if(Game.input.up.isPressed()) {
			selected--;
		}
		if(selected>=length || selected < 0) selected = 0;
		if(Game.input.s.isPressed()) {
			isOpen = false;
		}
		
		if(Game.input.right.isPressed()) {
			if(recipes.get(selected).canMake()) {
				recipes.get(selected).make();
			}
		}
	}
	
	public static void render() {
		for(int i = 0; i < recipes.size(); i++) {
			Game.screen.renderText(Game.WIDTH-8*7, i*8 + 16, recipes.get(i).result.name, 1);
			recipes.get(i).result.render(Game.screen, Game.WIDTH-8*8, i*8 + 16);
		}
		Game.screen.renderText(Game.WIDTH-9*8, selected*8 + 16, ">", 1);
		
		Game.screen.render(0, Game.HEIGHT-16, 0 * 8, 2 * 8, 8, 8);
		Game.screen.renderText(8, Game.HEIGHT-16, ""+recipes.get(selected).requiredWood, 1);
		Game.screen.render(40, Game.HEIGHT-16, 1 * 8, 2 * 8, 8, 8);
		Game.screen.renderText(48, Game.HEIGHT-16, ""+recipes.get(selected).requiredStone, 1);
		Game.screen.render(80, Game.HEIGHT-16, 3 * 8, 2 * 8, 8, 8);
		Game.screen.renderText(88, Game.HEIGHT-16, ""+recipes.get(selected).requiredGold, 1);
	}
	
	public static void addRecipe(CraftRecipe r) {
		recipes.add(r);
	}
}
