package mackthehobbit.ld26;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.net.URL;

import javax.imageio.ImageIO;
import javax.swing.JFrame;
import javax.swing.JPanel;

import mackthehobbit.ld26.entity.PlayerEntity;
import mackthehobbit.ld26.gfx.Screen;
import mackthehobbit.ld26.map.Map;

public class GameApplet extends Applet {
	public void init() {
		Game.g = new Game();
		
		this.setPreferredSize(new Dimension(Game.WIDTH * Game.SCALE - 10, Game.HEIGHT * Game.SCALE - 10));
		
		add(Game.g);
		
		this.addKeyListener(Game.input);
		this.requestFocus();
		this.setVisible(true);
		
		Game.g.addKeyListener(Game.input);
		
		Game.g.createBufferStrategy(2);
		
		Game.screen = new Screen(Game.g.getBufferStrategy());
		Game.map = new Map();
		Game.map.addEntity(new PlayerEntity(Game.map.spawnX, Game.map.spawnY));
		
		setLayout(new BorderLayout());
		add(Game.g, BorderLayout.CENTER);
		
	}
	
	public void start() {
		Intro intro = new Intro();
		while(intro.running()) {
			System.out.println("Ticking intro");
			intro.tick();
			Game.screen.tick();
			Game.g.doTickFps();
		}
		
		while(Game.g.running) {
			Game.g.doLoop();
		}
	}
	
	public void stop() {
		System.exit(0);
	}
}
