package mackthehobbit.ld26;

import java.applet.Applet;
import java.applet.AudioClip;
import java.net.URL;

public class Sound {
	public static Sound bump = new Sound("res/bump.wav", 1000);
	public static Sound rumble = new Sound("res/rumble.wav", 500);
	public static Sound hit = new Sound("res/hit.wav", 500);
	public static Sound dig = new Sound("res/dig.wav", 0);
	public static Sound hurt = new Sound("res/hurt.wav", 0);
	public static Sound max = new Sound("res/max.wav", 1000);
	
	private int playWait;
	private long lastPlayTick = 0;
	
	private AudioClip sound;
	
	public Sound(String path, int playWait) {
		this.playWait = playWait;
		try {
			URL url = this.getClass().getClassLoader().getResource(path);
			this.sound = Applet.newAudioClip(url);
		} catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public void play() {
		if(System.currentTimeMillis() >= lastPlayTick+playWait) {
			sound.play();
			lastPlayTick = System.currentTimeMillis();
		}
	}
	public void loop() {
		sound.loop();
	}
	public void stop() {
		sound.stop();
	}
}
