package mackthehobbit.ld26.entity;

import java.awt.Rectangle;
import java.util.Random;

import mackthehobbit.ld26.Game;
import mackthehobbit.ld26.gfx.Screen;

public class Entity {
	public int x;
	public int y;
	protected int prevTileX = -1, prevTileY = -1;
	
	protected int tickCount = 0;
	
	protected Random random = new Random();
	
	public Entity(int x, int y) {
		this.x = x;
		this.y = y;
		
		Game.map.setEntityTile(getTileX(), getTileY(), this);
	}
	
	public void move(int xm, int ym) {
		x += xm;
		y += ym;
	}
	
	public boolean collidesWith(Entity other) {
		return this.getBounds().intersects(other.getBounds());
	}
	
	public void collideWith(Entity other) {
		
	}
	
	public void tick() {
		tickCount++;
		if(!(getTileX() < 0 || getTileY() < 0 || getTileX() >= Game.map.width || getTileY() >= Game.map.height) && (getTileX()!=prevTileX || getTileY()!=prevTileY)) {
			Game.map.setEntityTile(getTileX(), getTileY(), this);
			prevTileX = getTileX();
			prevTileY = getTileY();
		}
	}
	
	public void render(Screen screen, int scrollX, int scrollY) {
		
	}
	
	public int getTileX() {
		return x/16;
	}
	public int getTileY() {
		return y/16;
	}
	
	public Rectangle getBounds() {
		Rectangle rect = new Rectangle();
		rect.setBounds(this.x-2, this.y-1, 4, 2);
		return rect;
	}
}
