package mackthehobbit.ld26.entity;

import mackthehobbit.ld26.Game;
import mackthehobbit.ld26.Sound;
import mackthehobbit.ld26.gfx.Screen;
import mackthehobbit.ld26.item.Item;
import mackthehobbit.ld26.item.ItemStore;
import mackthehobbit.ld26.map.Tile;

public class ZombieEntity extends Entity {
	private int walkDist = 0;
	private int health = 10;
	
	public ZombieEntity(int x, int y) {
		super(x, y);
		move(0,0);
	}
	
	public void move(int xm, int ym) {
		if(Game.map.getTileAt((x+xm)/16, (y+ym)/16)==Tile.water) return;
		if(!Game.map.getTileAt((x+xm)/16, (y+ym)/16).isSolid() && !((x+xm)/16 < 0 || (y+ym)/16 <= 0 || (x+xm)/16 >= Game.map.width || (y+ym)/16 >= Game.map.height))
			super.move(xm, ym);
	}
	
	public void collideWith(Entity other) {
		if(other instanceof PlayerEntity) {
			((PlayerEntity) other).hurt(20);
			Game.g.notify("Took "+20+" damage!");
		}
	}
	
	public void tick() {
		super.tick();
		if((x > Game.map.player.x - Game.WIDTH && x < Game.map.player.x + Game.WIDTH)&&(y > Game.map.player.y - Game.HEIGHT && y < Game.map.player.y + Game.HEIGHT)&&tickCount%3==0) {
			if(x > Game.map.player.x) {
				move(-1, 0);
			}
			if(x < Game.map.player.x) {
				move(1, 0);
			}
			if(y > Game.map.player.y) {
				move(0, -1);
			}
			if(y < Game.map.player.y) {
				move(0, 1);
			}
			walkDist++;
		}
		if(walkDist>=10) walkDist = 0;
	}
	
	public void render(Screen screen, int scrollX, int scrollY) {
		screen.render(x - 4 - scrollX, y - 8 - scrollY, 8, walkDist/5 * 8, 8, 8);
	}
	
	public void attack(int damage) {
		Sound.hit.play();
		health-=damage;
		Game.g.notify("Hit zombie with "+damage+" damage!");
		if(health<=0) {
			Game.map.removeEntity(this);
			if(random.nextInt(2)==0) {
				Game.inventory.addItem(new ItemStore(Item.meat, 1));
			}
		}
	}
}
