package mackthehobbit.ld26.item;

import mackthehobbit.ld26.Game;

public class Inventory {
	private ItemStore[] items = new ItemStore[] {
		new ItemStore(Item.hatchet, 1),
		new ItemStore(Item.none, 1),
		new ItemStore(Item.none, 0),
		new ItemStore(Item.none, 0),
		new ItemStore(Item.none, 0),
	};
	
	public int woodCount = 0;
	public int stoneCount = 0;
	public int goldCount = 1;
	
	public Inventory() {
		
	}
	
	public boolean addItem(ItemStore item) {
		int i = hasRoom(item);
		if(i >= 0) {
			if(items[i].getItem()==item.getItem()) {
				items[i].size+=item.size;
			}
			if(items[i].getItem()==Item.none){
				items[i].setItem(item.getItem(), item.size);
			}
			Game.g.notify("Got " + item.size + " " + item.getItem().name);
			return true;
		}
		return false;
	}
	
	public int hasRoom(ItemStore item) {
		
		for(int i=0; i < 5; i++) {
			if(items[i].getItem() == item.getItem()) {
				if (items[i].size < items[i].getItem().maxSize) {
					return i;
				}
			}
		}
		
		for(int i=0; i < 5; i++) {
			if(items[i].getItem()==Item.none) {
				return i;
			}
		}
		
		return -1;
	}
	
	public void removeItem(Item item, int count) {
		for(int i=0; i < 5; i++) {
			if(items[i].getItem() == item && items[i].size >= count) {
				items[i].size -= count;
				if(items[i].size <= 0) {
					count = 0-items[i].size;
					items[i] = new ItemStore(Item.none, 0);
				}
				else count = 0;
			}
		}
	}
	
	public boolean hasItem(Item item, int count) {
		for(int i=0; i < 5; i++) {
			if(items[i].getItem() == item && items[i].size >= count) {
				return true;
			}
		}
		return false;
	}
	
	public ItemStore getItem(int index) {
		return items[index];
	}
	
	public void use(int index) {
		if(Game.map.player.interactTimer > 0) {
			Game.map.player.interactTimer++;
			return;
		}
		if(items[index].use()) {
			items[index] = new ItemStore(Item.none, 0);
		}
	}
	
	public void addWood(int amount) {
		if(amount<=0) return;
		woodCount += amount;
		Game.g.notify("Got "+amount+" Wood.");
	}
	public void addStone(int amount) {
		if(amount<=0) return;
		stoneCount += amount;
		Game.g.notify("Got "+amount+" Stone.");
	}
	public void addGold(int amount) {
		if(amount<=0) return;
		goldCount += amount;
		Game.g.notify("Got "+amount+" Gold.");
	}
}
