package mackthehobbit.ld26.map;

import java.util.Random;

public class MapGen {
	private Random random = new Random();
	private int stack = 0;
	
	public MapGen(Map map) {
		generate(map);
	}
	
	public void generate(Map map) {
		for(int xt=0; xt < map.width; xt++) {
			for(int yt=0; yt < map.height; yt++) {
				map.setTileAt(xt, yt, Tile.water);
			}
		}
		
		for(int i=0; i < 320; i++) {
			generateIsle(map, random.nextInt((int) (map.width*0.75))+map.width/8, random.nextInt((int) (map.height*0.75))+map.height/8);
		}
	}

	private void generateIsle(Map map, int x, int y) {
		stack = 0;
		putIsleSegment(map, x, y);
		if(stack >= 12) {
			map.spawnX = x*16+8;
			map.spawnY = y*16+8;
			map.setTileAt(x, y, Tile.ground);
		}
	}
	private void putIsleSegment(Map map, int x, int y) {
		stack++;
		if(stack>=120) return;
		map.setTileAt(x, y, Tile.ground);
		if(random.nextInt(3)==1 && x*16!=map.spawnX && y*16!=map.spawnY) {
			map.setTileAt(x, y, Tile.tree);
		}
		if(random.nextInt(120)==1) {
			map.setTileAt(x, y, Tile.woodcutter);
		}
		if(random.nextInt(120)==1) {
			map.setTileAt(x, y, Tile.butcher);
		}
		if(random.nextInt(120)==1) {
			map.setTileAt(x, y, Tile.gardener);
		}
		if(random.nextInt(120)==1) {
			map.setTileAt(x, y, Tile.farmer);
		}
		if(random.nextInt(120)==1) {
			map.setTileAt(x, y, Tile.miner);
		}
		
		if(map.getTileAt(x+1, y)==Tile.water && random.nextInt(3)==1) {
			putIsleSegment(map, x+1, y);
		}
		if(map.getTileAt(x-1, y)==Tile.water && random.nextInt(3)==1) {
			putIsleSegment(map, x-1, y);
		}
		if(map.getTileAt(x, y+1)==Tile.water && random.nextInt(3)==1) {
			putIsleSegment(map, x, y+1);
		}
		if(map.getTileAt(x, y-1)==Tile.water && random.nextInt(3)==1) {
			putIsleSegment(map, x, y-1);
		}
	}
}
