package mackthehobbit.ld26.map;

import java.util.Random;

import mackthehobbit.ld26.Game;
import mackthehobbit.ld26.gfx.Screen;

public class Tile {
	public static Tile ground = new Tile();
	public static Tile pit = new PitTile();
	public static Tile wall = new WallTile();
	public static Tile tree = new TreeTile();
	public static Tile stump = new StumpTile();
	public static Tile water = new WaterTile();
	public static Tile potato1 = new PotatoTile(0);
	public static Tile potato2 = new PotatoTile(1);
	
	public static Tile woodcutter = new TraderNPCTile(10, 4, "Logger");
	public static Tile butcher = new TraderNPCTile(8, 4, "Butcher");
	public static Tile gardener = new TraderNPCTile(6, 4, "Gardener");
	public static Tile farmer = new TraderNPCTile(4, 4, "Farmer");
	public static Tile miner = new TraderNPCTile(10, 5, "Miner");
	
	protected Random random = new Random();
	
	public Tile() {
		
	}
	
	public void tick(int xt, int yt) {
		if(random.nextInt(600)==0 && (Game.map.player.getTileX()!=xt || Game.map.player.getTileY()!=yt)) {
			if(this==ground) {
				Game.map.setTileAt(xt, yt, Tile.tree);
			}
		}
	}
	
	public void render(Screen screen, int x, int y) {
		screen.render(x, y, 8 * 8, 3 * 8, 8, 8);
		screen.render(x + 8, y, 8 * 8, 3 * 8, 8, 8);
		screen.render(x, y + 8, 8 * 8, 3 * 8, 8, 8);
		screen.render(x + 8, y + 8, 8 * 8, 3 * 8, 8, 8);
	}

	public boolean isSolid() {
		return false;
	}
}
