package mackthehobbit.ld26.map;

import java.util.ArrayList;

import mackthehobbit.ld26.Game;
import mackthehobbit.ld26.gfx.Screen;
import mackthehobbit.ld26.item.Item;
import mackthehobbit.ld26.item.ItemStore;
import mackthehobbit.ld26.trade.TraderInput;
import mackthehobbit.ld26.trade.TraderOutput;

public class TraderNPCTile extends Tile {
	public ArrayList<TraderInput> inputs;
	public ArrayList<TraderOutput> outputs;
	private int spritex;
	private int spritey;
	private String name;
	
	public TraderNPCTile(int spritex, int spritey, String name) {
		this.spritex = spritex;
		this.spritey = spritey;
		this.name = name;
		this.inputs = new ArrayList<TraderInput>();
		this.outputs = new ArrayList<TraderOutput>();
		
		if(name=="Logger") {
			inputs.add(TraderInput.wood30);
			outputs.add(TraderOutput.gold1);
		}
		if(name=="Butcher") {
			inputs.add(TraderInput.gold1);
			outputs.add(TraderOutput.meat5);
			inputs.add(TraderInput.meat5);
			outputs.add(TraderOutput.gold1);
		}
		if(name=="Gardener") {
			inputs.add(TraderInput.gold1);
			outputs.add(TraderOutput.potato15);
			inputs.add(TraderInput.potato15);
			outputs.add(TraderOutput.gold1);
		}
		if(name=="Farmer") {
			inputs.add(TraderInput.gold1);
			outputs.add(TraderOutput.shovel1);
			inputs.add(TraderInput.shovel1);
			outputs.add(TraderOutput.gold1);
		}
		if(name=="Miner") {
			inputs.add(TraderInput.stone10);
			outputs.add(TraderOutput.gold1);
		}
	}
	
	public void render(Screen screen, int x, int y) {
		screen.render(x, y-8, 10 * 8, 2 * 8, 16, 16);
		screen.render(x, y+8, spritex * 8, spritey * 8, 16, 8);
		screen.renderText(x*4, y*4+7*4, name, 4);
	}
	
	public boolean isSolid() {
		return true;
	}
	
	public void tryTrade(Item selected) {
		for(int i=0; i<inputs.size(); i++) {
			if(inputs.get(i).isItem && inputs.get(i).item==selected) {
				if(doTrade(i)) return;
			}
		}
		if(selected==Item.none) {
			doTrade(0);
		}
	}
	
	public boolean doTrade(int index) {
		TraderInput in = inputs.get(index);
		TraderOutput out = outputs.get(index);
		if(in.canPay()) {
			String tradeString = "Traded "+in.getTradeString()+"for "+out.getTradeString();
			in.pay();
			out.give();
			Game.g.notify(tradeString);
			return true;
		}
		return false;
	}
	
}
