package mackthehobbit.ld26.trade;

import mackthehobbit.ld26.Game;
import mackthehobbit.ld26.item.Item;

public class TraderInput {
	public static TraderInput wood30 = new TraderInput(30, 0, 0);
	public static TraderInput stone10 = new TraderInput(0, 10, 0);
	public static TraderInput gold1 = new TraderInput(0, 0, 1);

	public static TraderInput meat5 = new TraderInput(Item.meat, 5);
	public static TraderInput potato15 = new TraderInput(Item.potato, 15);
	public static TraderInput shovel1 = new TraderInput(Item.shovel, 1);
	public static TraderInput hatchet1 = new TraderInput(Item.hatchet, 1);
	
	public boolean isItem;
	public Item item;
	public int itemCount;
	
	public int wood;
	public int stone;
	public int gold;
	
	public TraderInput(Item item, int itemCount) {
		isItem = true;
		this.item = item;
		this.itemCount = itemCount;
	}
	
	public TraderInput(int wood, int stone, int gold) {
		isItem = false;
		this.wood = wood;
		this.stone = stone;
		this.gold = gold;
	}
	
	public boolean canPay() {
		if(isItem) {
			if(Game.inventory.hasItem(item, itemCount)) {
				return true;
			}
		}
		else {
			if(Game.inventory.woodCount>=wood && Game.inventory.stoneCount>=stone && Game.inventory.goldCount>=gold) {
				return true;
			}
		}
		return false;
	}
	
	public void pay() {
		if(isItem) {
			Game.inventory.removeItem(item, itemCount);
		}
		else {
			Game.inventory.woodCount -= wood;
			Game.inventory.stoneCount -= stone;
			Game.inventory.goldCount -= gold;
		}
	}
	
	public String getTradeString() {
		if(isItem) {
			return itemCount+" "+item.name+" ";
		}
		else {
			String string = "";
			if(wood!=0){
				string = string+wood+" Wood ";
			}
			if(stone!=0){
				string = string+stone+" Stone ";
			}
			if(gold!=0){
				string = string+gold+" Gold ";
			}
			return string;
		}
	}
	
}
