package mackthehobbit.ld26.trade;

import mackthehobbit.ld26.Game;
import mackthehobbit.ld26.item.Item;
import mackthehobbit.ld26.item.ItemStore;

public class TraderOutput {
	public static TraderOutput gold1 = new TraderOutput(0, 0, 1);
	public static TraderOutput wood30 = new TraderOutput(0, 0, 30);
	
	public static TraderOutput meat5 = new TraderOutput(Item.meat, 5);
	public static TraderOutput potato15 = new TraderOutput(Item.potato, 15);
	public static TraderOutput shovel1 = new TraderOutput(Item.shovel, 1);
	public static TraderOutput hatchet1 = new TraderOutput(Item.hatchet, 1);
	
	public boolean isItem;
	public Item item;
	public int itemCount;
	
	public int wood;
	public int stone;
	public int gold;
	
	public TraderOutput(Item item, int itemCount) {
		isItem = true;
		this.item = item;
		this.itemCount = itemCount;
	}
	
	public TraderOutput(int wood, int stone, int gold) {
		isItem = false;
		this.wood = wood;
		this.stone = stone;
		this.gold = gold;
	}
	
	public void give() {
		if(isItem) {
			Game.inventory.addItem(new ItemStore(item, itemCount));
		}
		else {
			Game.inventory.woodCount += wood;
			Game.inventory.stoneCount += stone;
			Game.inventory.goldCount += gold;
		}
	}
	
	public String getTradeString() {
		if(isItem) {
			return itemCount+" "+item.name+" ";
		}
		else {
			String string = "";
			if(wood!=0){
				string = string+wood+" Wood ";
			}
			if(stone!=0){
				string = string+stone+" Stone ";
			}
			if(gold!=0){
				string = string+gold+" Gold ";
			}
			return string;
		}
	}
	
}
